# DO NOT EDIT! This file was auto-generated by crates/re_types_builder/src/codegen/python.rs
# Based on "crates/re_types/definitions/rerun/blueprint/archetypes/container_blueprint.fbs".

# You can extend this class by creating a "ContainerBlueprintExt" class in "container_blueprint_ext.py".

from __future__ import annotations

from typing import Any

from attrs import define, field

from ... import datatypes
from ..._baseclasses import Archetype
from ...error_utils import catch_and_log_exceptions
from .. import components

__all__ = ["ContainerBlueprint"]


@define(str=False, repr=False, init=False)
class ContainerBlueprint(Archetype):
    """**Archetype**: The top-level description of the Viewport."""

    def __init__(
        self: Any,
        container_kind: components.ContainerKindLike,
        *,
        display_name: components.NameLike | None = None,
        contents: components.IncludedContentsLike | None = None,
        primary_weights: components.PrimaryWeightsLike | None = None,
        secondary_weights: components.SecondaryWeightsLike | None = None,
        active_tab: datatypes.EntityPathLike | None = None,
        visible: components.VisibleLike | None = None,
    ):
        """
        Create a new instance of the ContainerBlueprint archetype.

        Parameters
        ----------
        container_kind:
            The class of the view.
        display_name:
            The name of the container.
        contents:
            `ContainerIds`s or `SpaceViewId`s that are children of this container.
        primary_weights:
            The weights of the primary axis. For `Grid` this is the column weights.

            For `Horizontal`/`Vertical` containers, the length of this list should always match the number of contents.
        secondary_weights:
            The weights of the secondary axis. For `Grid` this is the row weights. Ignored for `Horizontal`/`Vertical` containers.
        active_tab:
            Which tab is active.

            Only applies to `Tabs` containers.
        visible:
            Whether this container is visible.

            Defaults to true if not specified.
        """

        # You can define your own __init__ function as a member of ContainerBlueprintExt in container_blueprint_ext.py
        with catch_and_log_exceptions(context=self.__class__.__name__):
            self.__attrs_init__(
                container_kind=container_kind,
                display_name=display_name,
                contents=contents,
                primary_weights=primary_weights,
                secondary_weights=secondary_weights,
                active_tab=active_tab,
                visible=visible,
            )
            return
        self.__attrs_clear__()

    def __attrs_clear__(self) -> None:
        """Convenience method for calling `__attrs_init__` with all `None`s."""
        self.__attrs_init__(
            container_kind=None,  # type: ignore[arg-type]
            display_name=None,  # type: ignore[arg-type]
            contents=None,  # type: ignore[arg-type]
            primary_weights=None,  # type: ignore[arg-type]
            secondary_weights=None,  # type: ignore[arg-type]
            active_tab=None,  # type: ignore[arg-type]
            visible=None,  # type: ignore[arg-type]
        )

    @classmethod
    def _clear(cls) -> ContainerBlueprint:
        """Produce an empty ContainerBlueprint, bypassing `__init__`."""
        inst = cls.__new__(cls)
        inst.__attrs_clear__()
        return inst

    container_kind: components.ContainerKindBatch = field(
        metadata={"component": "required"},
        converter=components.ContainerKindBatch._required,  # type: ignore[misc]
    )
    # The class of the view.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    display_name: components.NameBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.NameBatch._optional,  # type: ignore[misc]
    )
    # The name of the container.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    contents: components.IncludedContentsBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.IncludedContentsBatch._optional,  # type: ignore[misc]
    )
    # `ContainerIds`s or `SpaceViewId`s that are children of this container.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    primary_weights: components.PrimaryWeightsBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.PrimaryWeightsBatch._optional,  # type: ignore[misc]
    )
    # The weights of the primary axis. For `Grid` this is the column weights.
    #
    # For `Horizontal`/`Vertical` containers, the length of this list should always match the number of contents.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    secondary_weights: components.SecondaryWeightsBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.SecondaryWeightsBatch._optional,  # type: ignore[misc]
    )
    # The weights of the secondary axis. For `Grid` this is the row weights. Ignored for `Horizontal`/`Vertical` containers.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    active_tab: components.ActiveTabBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.ActiveTabBatch._optional,  # type: ignore[misc]
    )
    # Which tab is active.
    #
    # Only applies to `Tabs` containers.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    visible: components.VisibleBatch | None = field(
        metadata={"component": "optional"},
        default=None,
        converter=components.VisibleBatch._optional,  # type: ignore[misc]
    )
    # Whether this container is visible.
    #
    # Defaults to true if not specified.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    __str__ = Archetype.__str__
    __repr__ = Archetype.__repr__
