# DO NOT EDIT! This file was auto-generated by crates/re_types_builder/src/codegen/python.rs
# Based on "crates/re_types/definitions/rerun/blueprint/components/secondary_weights.fbs".

# You can extend this class by creating a "SecondaryWeightsExt" class in "secondary_weights_ext.py".

from __future__ import annotations

from typing import Any, Sequence, Union

import numpy as np
import numpy.typing as npt
import pyarrow as pa
from attrs import define, field

from ..._baseclasses import BaseBatch, BaseExtensionType, ComponentBatchMixin
from ..._converters import (
    to_np_float32,
)

__all__ = [
    "SecondaryWeights",
    "SecondaryWeightsArrayLike",
    "SecondaryWeightsBatch",
    "SecondaryWeightsLike",
    "SecondaryWeightsType",
]


@define(init=False)
class SecondaryWeights:
    """
    **Component**: The weights of the secondary axis.

    For `Grid` this is the row weights.
    """

    def __init__(self: Any, weights: SecondaryWeightsLike):
        """
        Create a new instance of the SecondaryWeights component.

        Parameters
        ----------
        weights:
            The weighting of each container element.
        """

        # You can define your own __init__ function as a member of SecondaryWeightsExt in secondary_weights_ext.py
        self.__attrs_init__(weights=weights)

    weights: npt.NDArray[np.float32] = field(converter=to_np_float32)
    # The weighting of each container element.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    def __array__(self, dtype: npt.DTypeLike = None) -> npt.NDArray[Any]:
        # You can define your own __array__ function as a member of SecondaryWeightsExt in secondary_weights_ext.py
        return np.asarray(self.weights, dtype=dtype)


SecondaryWeightsLike = SecondaryWeights
SecondaryWeightsArrayLike = Union[
    SecondaryWeights,
    Sequence[SecondaryWeightsLike],
]


class SecondaryWeightsType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.components.SecondaryWeights"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self, pa.list_(pa.field("item", pa.float32(), nullable=False, metadata={})), self._TYPE_NAME
        )


class SecondaryWeightsBatch(BaseBatch[SecondaryWeightsArrayLike], ComponentBatchMixin):
    _ARROW_TYPE = SecondaryWeightsType()

    @staticmethod
    def _native_to_pa_array(data: SecondaryWeightsArrayLike, data_type: pa.DataType) -> pa.Array:
        raise NotImplementedError  # You need to implement native_to_pa_array_override in secondary_weights_ext.py
